//
// Created by hangshu on 22-4-26.
//

#ifndef SYSY2022_BJTU_FUNCTION_HH
#define SYSY2022_BJTU_FUNCTION_HH
#include "string"
#include <vector>
#include <memory>
#include "BasicBlock.hh"
#include "Value.hh"
#include <iostream>
class Function{
public:
    bool hasArrayParam = false;
    bool hasGlobalVar = false;
    int stackSize = 0;
    int bbCnt = 0;
    int varCnt = 0;
    std::string name;
    Type* return_type;
    std::vector<BasicBlock*> basicBlocks;
    std::vector<Value*> params;
    std::set<Value*> allocaVars;
    bool variant_params = false;
    Function(std::string name,Type* type){
        this->name = name;
        return_type = type;
    }
    Function(std::string name,Type* type,std::vector<Value*> params) {
        this->name = name;
        this->return_type = type;
        this->params = params;
    }
    void pushBB(BasicBlock* basicBlock);
    std::vector<BasicBlock*> getBB();
    bool isArgs(std::string name);
    void clear();
    void print(std::ostream& out);
};
#endif //SYSY2022_BJTU_FUNCTION_HH