//
// Created by hangshu on 22-6-23.
//

#ifndef SYSY2022_BJTU_IRMANAGER_HH
#define SYSY2022_BJTU_IRMANAGER_HH

#include "Instruction.hh"

class AllocIRManager {
public:
    static Instruction *getIR(Value *v);
    static Instruction *getIR(Value *v, int arrayLen);
};

class LoadIRManager {
public:
    static Instruction *getIR(Value *v, Value *t);
};

class StoreIRManager {
public:
    static Instruction *getIR(Value *dst, TempVal src);
    static Instruction *getIR(Value *dst, Value* src) ;
    static Instruction *getIR(Value *dst, int src, Type* type);
    static Instruction *getIR(Value *dst, float src, Type* type) ;
};

class CastIRManager {
public:
    static Instruction *getIR(Value *dst, TempVal src);
};

class ArithmeticIRManager {
public:
    //v1.type should equals to v2.type
    static Instruction *getIR(TempVal res, TempVal v1, TempVal v2, char op) ;
};

class UnaryIRManager {
public:
    static Instruction *getIR(TempVal res, TempVal v, char op) ;
};

class LogicalIRManager {
public:
    static Instruction *getIR(TempVal res, TempVal v1, TempVal v2, relop op);
};

#endif //SYSY2022_BJTU_IRMANAGER_HH