//
// Created by hangshu on 22-8-6.
//
#include "BasicBlock.hh"
void BasicBlock::pushIr(Instruction* instruction) {
    ir.push_back(instruction);
}
std::vector<Instruction*>& BasicBlock::getIr() {
    return ir;
}
void BasicBlock::pushVar(Value *v) {
    vars.push_back(v);
}
void BasicBlock::insertDomFrontier(BasicBlock* bb) {
    domFrontier.insert(bb);
}
std::set<BasicBlock*> BasicBlock::getDomFrontier() {
    return domFrontier;
}
void BasicBlock::pushPre(BasicBlock* nb){
    if (std::find(preBBs.begin(),preBBs.end(),nb) == preBBs.end())
        preBBs.push_back(nb);
}
void BasicBlock::pushSucc(BasicBlock* nb){
    if (std::find(succBBs.begin(),succBBs.end(),nb) == succBBs.end())
        succBBs.push_back(nb);
}
void BasicBlock::setPre(std::vector<BasicBlock*> pre){preBBs = pre;}
void BasicBlock::setSucc(std::vector<BasicBlock*> succ){succBBs = succ;}
std::vector<BasicBlock*> BasicBlock::getPre(){return preBBs;}
std::vector<BasicBlock*> BasicBlock::getSucc(){return succBBs;}
void BasicBlock::setIdom(BasicBlock* idom) { this->idom = idom; }
BasicBlock* BasicBlock::getIdom() { return idom; }
void BasicBlock::pushDomTreeSuccNode(BasicBlock* bb) { this->domTreeSuccNode.push_back(bb); }
std::vector<BasicBlock*> BasicBlock::getDomTreeSuccNode() { return domTreeSuccNode; }

//add for codegen
void BasicBlock::pushInstr(Instr* instr) {instrs.push_back(instr);}
std::vector<Instr*>& BasicBlock::getInstrs() {return instrs;}

void NormalBlock::print(std::ostream& out){
        out << name << std::endl;
        for (size_t i = 0; i < ir.size(); ++i) {
            std::cout << "\t";
            ir[i]->print(out);
        }
        std::cout<<"\tPreBBs:";
        std::vector<BasicBlock*> temp = getPre();
        for (size_t i = 0; i < temp.size(); i++){
            std::cout<<" "<<temp[i]->name;
        }
        std::cout<<"\n\tSuccBBs:";
        temp = getSucc();
        for (size_t i = 0; i < temp.size(); i++){
            std::cout<<" "<<temp[i]->name;
        }
        std::cout<<"\n";
};

void CondBlock::print(std::ostream& out){
        out << name << std::endl;
        for (size_t i = 0; i < ir.size(); ++i) {
            std::cout << "\t";
            ir[i]->print(out);
        }
}


void SelectBlock::print(std::ostream& out){
        for (size_t i = 0; i < cond.size(); ++i) {
            cond[i]->print(out);
        }
        for (size_t i = 0; i < ifStmt.size(); ++i) {
            ifStmt[i]->print(out);
        }
        for (size_t i = 0; i < elseStmt.size(); ++i) {
            elseStmt[i]->print(out);
        }
};
void SelectBlock::clear(){
        auto iter = cond.begin();
        while (iter != cond.end()){
            if ((*iter)->ir.empty() && !dynamic_cast<CondBlock*>(*iter)->val.getType()) {
                iter = cond.erase(iter);
            }else {
                ++iter;
            }
        }

        iter = ifStmt.begin();
        while (iter != ifStmt.end()){
            if (typeid(**iter) == typeid(NormalBlock)){
                if ((*iter)->ir.empty()) {
                    iter = ifStmt.erase(iter);
                }else {
                    ++iter;
                }
            }else {
                (*iter)->clear();
                ++iter;
            }
        }
        iter = elseStmt.begin();
        while (iter != elseStmt.end()){
            if (typeid(**iter) == typeid(NormalBlock)){
                if ((*iter)->ir.empty()) {
                    iter = elseStmt.erase(iter);
                }else {
                    ++iter;
                }
            }else {
                (*iter)->clear();
                ++iter;
            }
        }
}

void IterationBlock::print(std::ostream& out) {
        for (size_t i = 0; i < cond.size(); ++i) {
            cond[i]->print(out);
        }
        for (size_t i = 0; i < whileStmt.size(); ++i) {
            whileStmt[i]->print(out);
        }
}
void IterationBlock::clear() {
        auto iter = cond.begin();
        while (iter != cond.end()){
            if ((*iter)->ir.empty() && !dynamic_cast<CondBlock*>(*iter)->val.getType()) {
                iter = cond.erase(iter);
            }else {
                ++iter;
            }
        }
        iter = whileStmt.begin();
        while (iter != whileStmt.end()){
            if (typeid(**iter) == typeid(NormalBlock)){
                if ((*iter)->ir.empty()) {
                    iter = whileStmt.erase(iter);
                }else {
                    ++iter;
                }
            }else {
                (*iter)->clear();
                ++iter;
            }
        }
}