//
// Created by hangshu on 22-8-6.
//
#include "Function.hh"
void Function::pushBB(BasicBlock* basicBlock) {
    basicBlocks.push_back(basicBlock);
}
std::vector<BasicBlock*> Function::getBB() {
    return basicBlocks;
}
bool Function::isArgs(std::string name) {
    for (size_t i = 0; i < params.size(); ++i) {
        if (params[i]->getName() == name) return true;
    }
    return false;
}
void Function::clear() {
    auto iter = basicBlocks.begin();
    while(iter != basicBlocks.end()) {
        if (typeid(**iter) == typeid(NormalBlock)){
            if ((*iter)->ir.empty()) {
                iter = basicBlocks.erase(iter);
            }else {
                ++iter;
            }
        }else {
            (*iter)->clear();
            ++iter;
        }
    }
}
void Function::print(std::ostream& out) {
    out << "define ";
    return_type->print(out);
    out << "@" << name << "(";
    for (size_t i = 0; i < params.size(); ++i) {
        params[i]->print(out);
        if (i != params.size() - 1){
            out << ",";
        }
    }
    out << ")" <<std::endl;
    for (size_t i = 0; i < basicBlocks.size(); ++i) {
        basicBlocks[i]->print(out);
    }
}