//
// Created by hangshu on 22-8-6.
//
#include "Instruction.hh"
#include "BasicBlock.hh"
#include "Function.hh"
void MoveIR::print(std::ostream& out){
        dst->print(out);
        out << " = ";
        src->print(out);
        out << "\n";
};

void AllocIIR::print(std::ostream& out) {
        v->print(out);
        out << " = AllocaI";
        if(isArray)
        out << "(" << arrayLen << ")";
        out << std::endl;
}
void AllocFIR::print(std::ostream& out) {
        v->print(out);
        out << " = AllocaF";
        if(isArray)
        out << "(" << arrayLen << ")";
        out << std::endl;
}

void LoadIIR::print(std::ostream& out){
        v1->print(out);
        out << " = LoadI ";
        v2->print(out);
        out << std::endl;
}

void LoadFIR::print(std::ostream& out) {
        v1->print(out);
        out << " = LoadF ";
        v2->print(out);
        out << std::endl;
}

void StoreIIR::print(std::ostream& out){
        out << "StoreI ";
        src.print(out);
        out << " ";
        dst->print(out);
        out << std::endl;
}

void StoreFIR::print(std::ostream& out) {
        out << "StoreF ";
        src.print(out);
        out << " ";
        dst->print(out);
        out << std::endl;
}

void CastInt2FloatIR::print(std::ostream& out) {
    v1->print(out);
    out << " = CastInt2Float ";
    v2->print(out);
    out << std::endl;
}

void CastFloat2IntIR::print(std::ostream& out) {
        v1->print(out);
        out << " = CastFloat2Int ";
        v2->print(out);
        out << std::endl;
}

void AddIIR::print(std::ostream& out) {
        res.print(out);
        out << " = AddI ";
        left.print(out);
        out << " ";
        right.print(out);
        out << std::endl;
}

void AddFIR::print(std::ostream& out) {
        res.print(out);
        out << " = AddF ";
        left.print(out);
        out << " ";
        right.print(out);
        out << std::endl;
}

void SubIIR::print(std::ostream& out) {
        res.print(out);
        out << " = SubI ";
        left.print(out);
        out << " ";
        right.print(out);
        out << std::endl;
}

void SubFIR::print(std::ostream& out) {
        res.print(out);
        out << " = SubF ";
        left.print(out);
        out << " ";
        right.print(out);
        out << std::endl;
}

void MulIIR::print(std::ostream& out) {
        res.print(out);
        out << " = MulI ";
        left.print(out);
        out << " ";
        right.print(out);
        out << std::endl;
}

void MulFIR::print(std::ostream& out) {
        res.print(out);
        out << " = MulF ";
        left.print(out);
        out << " ";
        right.print(out);
        out << std::endl;
}

void DivIIR::print(std::ostream& out) {
        res.print(out);
        out << " = DivI ";
        left.print(out);
        out << " ";
        right.print(out);
        out << std::endl;
}
void DivFIR::print(std::ostream& out) {
    res.print(out);
    out << " = DivF ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}

void ModIR::print(std::ostream& out){
        res.print(out);
        out << " = Mod ";
        left.print(out);
        out << " ";
        right.print(out);
        out << std::endl;
}

void UnaryIR::print(std::ostream& out) {
        res.print(out);
        out << " = ";
        if (res.isInt()) {
            switch (op) {
                case OP::NEG:
                    out << "NEGF ";
                    break;
                case OP::NOT:
                    out << "NOTF ";
                    break;
            }
        } else {
            switch (op) {
                case OP::NEG:
                    out << "NEGF ";
                    break;
                case OP::NOT:
                    out << "NOTF ";
                    break;
            }
        }
        v.print(out);
        out << std::endl;
}

void LTIIR::print(std::ostream& out) {
        res.print(out);
        out << " = LTI ";
        left.print(out);
        out << " ";
        right.print(out);
        out << std::endl;
}

void LTFIR::print(std::ostream& out) {
    res.print(out);
    out << " = LTF ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}

void LEIIR::print(std::ostream& out) {
    res.print(out);
    out << " = LEI ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}

void LEFIR::print(std::ostream& out) {
    res.print(out);
    out << " = LEF ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}

void GTIIR::print(std::ostream& out) {
    res.print(out);
    out << " = GTI ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}

void GTFIR::print(std::ostream& out) {
    res.print(out);
    out << " = GTF ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}

void GEFIR::print(std::ostream& out) {
    res.print(out);
    out << " = GEF ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}
void GEIIR::print(std::ostream& out) {
    res.print(out);
    out << " = GEI ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}

void EQUIIR::print(std::ostream& out) {
    res.print(out);
    out << " = EQUI ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}

void EQUFIR::print(std::ostream& out) {
    res.print(out);
    out << " = EQUF ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}

void NEIIR::print(std::ostream& out) {
    res.print(out);
    out << " = NEI ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}
void NEFIR::print(std::ostream& out) {
    res.print(out);
    out << " = NEF ";
    left.print(out);
    out << " ";
    right.print(out);
    out << std::endl;
}

void BreakIR::print(std::ostream& out) {
        out << "break" << std::endl;
}

void ContinueIR::print(std::ostream& out) {
    out << "continue" << std::endl;
}

void ReturnIR::print(std::ostream& out){
        out << "ret ";
        if (v) {
            v->print(out);
        }else if (useInt) {
            out << "int " << retInt;
        }else if (useFloat){
            out << "float " << retFloat;
        }
        out << "\n";
}

void JumpIR::print(std::ostream& out) {
        out << "goto ";
        out << target->name;
        out << "\n";
}

void BranchIR::print(std::ostream& out) {
        out << "goto ";
        cond->print(out);
        out << " ？ ";
        if(trueTarget) {
            out << trueTarget->name;
        }
        out << " : ";
        if(falseTarget) {
            out << falseTarget->name;
        }
        out << "\n";
}

void GEPIR::print(std::ostream& out) {
        v1->print(out);
        out << " = GEP ";
        v2->print(out);
        if(v3) {
            out << " ";
            v3->print(out);
            out << std::endl;
        }else {
            out << " " << arrayLen << std::endl;
        }
};

void CallIR::print(std::ostream& out) {
        if (returnVal) {
            returnVal->print(out);
            out << " = ";
        }
        out << "call " << func->name << "(";
        for (size_t i = 0; i < args.size(); ++i) {
            if(args[i].getVal()) {
                args[i].getVal()->print(out);
            }else {
                if(args[i].isInt()) {
                    out << args[i].getInt();
                }else if (args[i].isFloat()){
                    out << args[i].getFloat();
                } else {
                    out << args[i].getString();
                }
            }
            if (i < args.size() - 1) {
                out << " , ";
            }
        }
        out << ")\n";
}

void PhiIR::print(std::ostream& out) {
        dst->print(out);
        out << " = Phi(";
        for(auto iter(params.begin()); iter != params.end(); iter++) {
            out << iter->first->name << " ";
            // TempVal* temp = dynamic_cast<TempVal*>(iter->second);
            if(!iter->second) {
                out << "nullptr";
            }
            else iter->second->print(out);
            out << ", ";
        }
        out << "\b\b)" << std::endl;
}